//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "ChatEdit1.h"
#include <values.h>
#pragma resource "*.res"
#pragma package(smart_init)

//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//
#define NRSMILIES 35
#define SMILESIZE 20
const char SmileCodes[NRSMILIES][4]={"8-|",":-/",":O",">:)","0:)",":-&","(:|","8-}",":x","X-(",":((",":-B",":-$","=P~","=D>",":\">",":>",":))",
                                     "=;","[-(",":-?",":D",":p","B-)",":|","I-)",":o)","#-o",";)o",":-*",":-S","/:)",":)",":(",";)"};
static inline void ValidCtrCheck(TChatEdit *)
{
    new TChatEdit(NULL);
}
//---------------------------------------------------------------------------
namespace Chatedit1
{
    void __fastcall PACKAGE Register()
    {
        TComponentClass classes[1] = {__classid(TChatEdit)};
        RegisterComponents("Tod", classes, 0);
    }
}
//---------------------------------------------------------------------------



//.............Constructor..........................
__fastcall TChatEdit::TChatEdit(TComponent* Owner)
    : TPaintBox(Owner)
{
FLines =new TStringList;
DisplayLines=new TStringList;
FFont=new TFont;
Canvas->Font=FFont;
Smilies=new Graphics::TBitmap;
FPosition=0;
FScrollBar=NULL;
FBkColor=clWhite;
FTextColor1=clBlack;
FTextColor2=clBlack;
FTextColor3=clBlack;
FTextColor4=clBlack;
FTextColor5=clBlack;

}
//..............Loads the smilies from a bitmap ....
void __fastcall TChatEdit::LoadSmilies()
{
if(FileExists(FSmiliesFile)) Smilies->LoadFromFile(FSmiliesFile);
Smilies->TransparentMode=tmAuto;
Smilies->Transparent=true;

};

//..............Calculates the text width considering smiles...
int __fastcall TChatEdit::TextWidth(AnsiString s)
{
AnsiString t,temp;
t=s;
int nrsml=0,sml;
  for(int j=0;j<NRSMILIES;j++)//finds first smile pos
  {
  temp=SmileCodes[j];
  while(sml=t.Pos(temp))
    {
     nrsml++;
     t.Delete(sml,temp.Length());
    }
  }
return Canvas->TextWidth(t)+SMILESIZE*nrsml;
};
//..............Processes the lines to display ....
void __fastcall TChatEdit::ProcessDisplay()
{
int i=Position-1;
int nl=0,p,q;
AnsiString Line,DLine,t;
TStringList *revers;
revers=new TStringList;
DisplayLines->Clear();
while((nl<NrLines)&&(i>=0))
 {
  Line=FLines->Strings[i];

   if(TextWidth(Line)>Width)
    {
      Line.Delete(1,1);
      revers->Clear();
      while(Line.Length()>0)
       {

       p=1;
       while((TextWidth(Line.SubString(1,p))<Width-3)&&(p<Line.Length())) p++;
       if(p>=Line.Length()) DLine=Line.SubString(1,p);
         else
              {
              DLine=Line.SubString(1,p-1);
              q=0;
              q=DLine.LastDelimiter(" ");
              if(q>0) DLine.Delete(q+1,DLine.Length()-q);
              }
       Line.Delete(1,DLine.Length());
       t=FLines->Strings[i][1];
       DLine=t+DLine;
       nl++;
       revers->Add(DLine);
       }
      for(int y=revers->Count-1;y>=0;y--)
        DisplayLines->Add(revers->Strings[y]);
    }
   else
    {
    DisplayLines->Add(Line);
    nl++;
    }
 i--;
 }
delete revers;
};
//...............Loaded..............
 void __fastcall TChatEdit::Loaded(void)
{
TPaintBox::Loaded();
ResetCanvas();
Canvas->Font=FFont;
if(FileExists(FSmiliesFile)) Smilies->LoadFromFile(FSmiliesFile);
       else Application->MessageBox("Smilies file not found","Error",MB_OK);
Smilies->TransparentMode=tmAuto;
Smilies->Transparent=true;

Position=1;
};
//.................ResetCanvas........................
void __fastcall TChatEdit::ResetCanvas()
{
Canvas->Brush->Style=bsSolid;
Canvas->Brush->Color=clWindow;
Canvas->Pen->Color=clBlack;
Canvas->Pen->Mode=pmCopy;
Canvas->Pen->Style=psSolid;
};
//............Clears the chat text....................
void __fastcall TChatEdit::Clear()
{
FLines->Clear();
Position=0;
};
//...........Add Lines................................
void __fastcall TChatEdit::AddLines(TStringList* Value)
{

int i;
if(!Value->Count) return;
FLines->AddStrings(Value);
FPosition=FLines->Count;
if(FScrollBar)
 {
 FScrollBar->Max=FLines->Count-1;
 FScrollBar->Position=FPosition;
 }
ProcessDisplay();
Repaint();

};

//...........AddLine Lines................................
void __fastcall TChatEdit::AddLine(AnsiString ns)
 {
  FLines->Add(ns);
  FPosition=FLines->Count;
  if(FScrollBar)
   {
   FScrollBar->Max=FLines->Count-1;
   FScrollBar->Position=FPosition;
   }
  ProcessDisplay();
  Repaint();
 };
//..................SetPosition.....................
void __fastcall TChatEdit::SetPosition(unsigned int np)
{
if(FPosition==np) return;
if(np>FLines->Count) np=FLines->Count;
FPosition=np;
ProcessDisplay();
Repaint();
};
//...........SetFont..............................
void __fastcall TChatEdit::SetFont(TFont *NF)
{
FFont->Assign(NF);
Canvas->Font=FFont;
Repaint();
}
//.................GetNrLines......................
int __fastcall TChatEdit::GetNrLines()
{
FNrLines=(ClientHeight)/(Canvas->TextHeight("T")>SMILESIZE?Canvas->TextHeight("T"):SMILESIZE);
return FNrLines;
};

//...........SetScrollBar.............................
void __fastcall TChatEdit::SetScrollBar(TScrollBar *ns)
{
FScrollBar=ns;
FScrollBar->Max=NrLines;
FScrollBar->Min=0;
FScrollBar->Kind=sbVertical;
FScrollBar->Left=Left+Width;
FScrollBar->Top=Top;
FScrollBar->Height=Height;
FScrollBar->LargeChange=NrLines;
FScrollBar->SmallChange=1;
};
//.................SetBkColor.....................
void __fastcall TChatEdit::SetBkColor(TColor nc)
{
FBkColor=nc;
Repaint();
};

//.................SetTextColor1.....................
void __fastcall TChatEdit::SetTextColor1(TColor nc)
{
FTextColor1=nc;
Repaint();
};
//.................SetTextColor2.....................
void __fastcall TChatEdit::SetTextColor2(TColor nc)
{
FTextColor2=nc;
Repaint();
};
//.................SetTextColor3.....................
void __fastcall TChatEdit::SetTextColor3(TColor nc)
{
FTextColor3=nc;
Repaint();
};
//.................SetTextColor4.....................
void __fastcall TChatEdit::SetTextColor4(TColor nc)
{
FTextColor4=nc;
Repaint();
};
//.................SetTextColor5.....................
void __fastcall TChatEdit::SetTextColor5(TColor nc)
{
FTextColor5=nc;
Repaint();
};

//...........Paint................................
void __fastcall TChatEdit::Paint(void)
{
  int i;
  //.............base display.....
  Graphics::TBitmap *offscreen;
  offscreen=new Graphics::TBitmap;
  offscreen->Height=ClientHeight;
  offscreen->Width=ClientWidth;
  offscreen->Canvas->Brush->Color=FBkColor;
  offscreen->Canvas->FillRect(ClientRect);
  offscreen->Canvas->Brush->Color=FBkColor;
  offscreen->Canvas->FrameRect(ClientRect);
  offscreen->Canvas->Brush=Canvas->Brush;
  offscreen->Canvas->Font=Canvas->Font;
  offscreen->Canvas->Brush->Color=BkColor;
  Canvas->Draw(0,0,offscreen);
  //.............end base display....
  if(!DisplayLines->Count) {return;}
  int Cursory,Cursorx;  //y position of the text being displayed
  int textheight=offscreen->Canvas->TextHeight("T");
  Cursory=ClientHeight-5-(textheight>SMILESIZE?textheight:SMILESIZE);
  i=0;

  int smilenr;
  int smilepos[100];
  int smiletype[100];
  //parcurge liniile de text care se afiseaza
  AnsiString Line="";
 for(i=0;i<DisplayLines->Count;i++)
   {
         Line=DisplayLines->Strings[i];
                   Cursorx=3;
          smilenr=0; //nr de smileuri
          AnsiString temp;
          int minsml=MAXINT,sml,tip;//first smile,curent smile,smile type
          //finds smiles, deletes smiles from string and sets smilepos and smile type
          do
           {
            minsml=MAXINT  ;
            for(int j=0;j<NRSMILIES;j++)//finds first smile pos
             {

             temp=SmileCodes[j];
             sml=Line.Pos(temp);
             if((sml<minsml)&&(sml>0))
                      {
                      minsml=sml;
                      tip=j;
                      }
              }
                if(minsml!=MAXINT)//eliminates smile and ads smile to list
                 {
                  temp=SmileCodes[tip];
                  Line=Line.Delete(minsml,temp.Length());
                  smilepos[smilenr]=minsml-1;
                  smiletype[smilenr]=tip;
                  smilenr++;
                  }
            }
           while(minsml!=MAXINT);
          //if no smile exist in string
          if(!smilenr)
           {
           switch(Line[1])
           {
           case '1':offscreen->Canvas->Font->Color=FTextColor1;break;
           case '2':offscreen->Canvas->Font->Color=FTextColor2;break;
           case '3':offscreen->Canvas->Font->Color=FTextColor3;break;
           case '4':offscreen->Canvas->Font->Color=FTextColor4;break;
           case '5':offscreen->Canvas->Font->Color=FTextColor5;break;
           };
           Line.Delete(1,1);
           offscreen->Canvas->TextOut(Cursorx,Cursory,Line);
           Cursorx=3;
           Cursory=Cursory-(textheight>SMILESIZE?textheight:SMILESIZE);

           }
             else
              {
              //at this point the smiles should be eliminated and their
              //positions and types stored in smilepos and smiletype

              //display
              int k;
              int curcar=1;//curent caracter in string (curent substring start)
              switch(Line[1])
                   {
                   case '1':offscreen->Canvas->Font->Color=FTextColor1;break;
                   case '2':offscreen->Canvas->Font->Color=FTextColor2;break;
                   case '3':offscreen->Canvas->Font->Color=FTextColor3;break;
                   case '4':offscreen->Canvas->Font->Color=FTextColor4;break;
                   case '5':offscreen->Canvas->Font->Color=FTextColor5;break;
                   };
                   Line.Delete(1,1);
              for(k=0;k<smilenr;k++)
                  {


                  temp=Line.SubString(curcar,smilepos[k]-curcar);
                  curcar=smilepos[k];
                  offscreen->Canvas->TextOut(Cursorx,Cursory,temp);
                  Cursorx=Cursorx+offscreen->Canvas->TextWidth(temp);
                  TRect sursa,dest;
                  dest.Left=Cursorx;
                  if(textheight>SMILESIZE)
                        dest.Top=Cursory+(textheight-SMILESIZE)/2;
                     else
                          dest.Top=Cursory-(textheight-SMILESIZE)/2;
                  dest.Right=dest.Left+SMILESIZE;
                  if(dest.Right>ClientWidth-1) dest.Right=ClientWidth-1;
                  dest.Bottom=dest.Top+SMILESIZE;
                  if(dest.Bottom>ClientHeight-1) dest.Bottom=ClientHeight-1;
                  sursa.Left=(smiletype[k]%5)*SMILESIZE ;
                  sursa.Top=(smiletype[k]/5)*SMILESIZE;
                  sursa.Right=sursa.Left+SMILESIZE;
                  sursa.Bottom=sursa.Top+SMILESIZE;
                  offscreen->Canvas->BrushCopy(dest,Smilies,sursa,Smilies->TransparentColor);
                  Cursorx=Cursorx+SMILESIZE;

                  }
               //this displays the text after the last smile
               temp=Line.SubString(curcar,smilepos[k]-1);
               offscreen->Canvas->TextOut(Cursorx,Cursory,temp);
               //end
               Cursorx=3;
               Cursory=Cursory-(textheight>SMILESIZE?textheight:SMILESIZE);

             }
       
       }

 Canvas->Draw(0,0,offscreen);
 };


